/* Generated By:JavaCC: Do not edit this line. linkAlgebraParser.java */
package parsers;

import java.util.*;
import java.awt.*;
import java.awt.font.*;
import java.awt.geom.*;
import applications.collages.*;
import applications.links.*;
import terms.*;
import util.*;

public class linkAlgebraParser implements linkAlgebraParserConstants {

  private nameParser names;
  private Hashtable transTable = new Hashtable();
  private Hashtable constTable = new Hashtable();
  private Hashtable colTable = new Hashtable();
  private ASCII_CharStream inputStream = null;
  private linkAlgebra result;

  // Used as global variables by segments(...):
  float firstCx, firstCy, firstPx, firstPy, lx, ly, rx, ry, px, py;
  boolean close;

  public linkAlgebraParser(ASCII_CharStream input) {
    this(new linkAlgebraParserTokenManager(input));
    names = new nameParser(input);
    inputStream = input;
  }

  private AffineTransform linearMapping(double a, double b, double a2, double b2,
                               double c, double d, double c2, double d2)
  throws ParseException {
    double[][] eqSys = {{0, 0, 0, 0, 0}, {0, 0, 0, 0, 0}, {0, 0, 0, 0, 0}, {0, 0, 0, 0, 0}};
    eqSys[0][0] = eqSys[1][2] = a;
    eqSys[0][1] = eqSys[1][3] = b;
    eqSys[2][0] = eqSys[3][2] = c;
    eqSys[2][1] = eqSys[3][3] = d;
    eqSys[0][4] = a2; eqSys[1][4] = b2; eqSys[2][4] = c2; eqSys[3][4] = d2;
    if (eqSys[0][0] == 0) {
      swap(eqSys, 0, 2);
      swap(eqSys, 1, 3);
    }
    double det = eqSys[0][0]*eqSys[2][1] - eqSys[0][1]*eqSys[2][0];
    if (det == 0) throw
      new ParseException("vectors (" + a + ", " + b + ") and (" + c + ", " + d + ") linearly dependent");
    double m12 = (eqSys[0][0] * eqSys[2][4] - eqSys[2][0] * eqSys[0][4]) / det;
    double m11 = (eqSys[0][4] - eqSys[0][1] * m12)/eqSys[0][0];
    double m22 = (eqSys[0][0] * eqSys[3][4] - eqSys[2][0] * eqSys[1][4]) / det;
    double m21 = (eqSys[1][4] - eqSys[0][1] * m22)/eqSys[0][0];
    return new AffineTransform(m11, m21, m12, m22, 0, 0);
  }

  private static void swap(double[][] matrix, int line1, int line2) {
    double[] help = (double[])matrix[line1].clone();
    matrix[line1] = matrix[line2];
    matrix[line2] = help;
  }

  private AffineTransform affineMapping(double a, double b, double a2, double b2,
                               double c, double d, double c2, double d2,
                               double e, double f, double e2, double f2)
  throws ParseException {
    AffineTransform result = AffineTransform.getTranslateInstance(-e,-f);
    a -= e; b -= f; c -= e; d -= f;
    a2 -= e2; b2 -= f2; c2 -= e2; d2 -= f2;
    try {
      AffineTransform lin = linearMapping(a, b, a2, b2, c, d, c2, d2);
      result.preConcatenate(lin);
    } catch (ParseException exc) { throw new ParseException("vectors linearly dependent"); }
    result.preConcatenate(AffineTransform.getTranslateInstance(e2,f2));
    return result;
  }

  private AffineTransform similarity(double a, double b, double a2, double b2,
                                                             double c, double d, double c2, double d2)
  throws ParseException {
    a -= c; b -= d; a2 -= c2; b2 -= d2;
    double len1 = Math.sqrt(a*a+b*b);
    double len2 = Math.sqrt(a2*a2+b2*b2);
    if (len1 == 0) throw new ParseException("pre-images in definition of similarity must not be identical");
    if (len2 == 0) {
      AffineTransform result = AffineTransform.getScaleInstance(0,0);
      result.preConcatenate(AffineTransform.getTranslateInstance(c2, d2));
      return result;
    }
    AffineTransform result = AffineTransform.getTranslateInstance(-c,-d);
    result.preConcatenate(AffineTransform.getScaleInstance(len2/len1,len2/len1));
    result.preConcatenate(AffineTransform.getRotateInstance(Math.atan2(b2/len2,a2/len2) - Math.atan2(b/len1,a/len1)));
    result.preConcatenate(AffineTransform.getTranslateInstance(c2,d2));
    return result;
  }

  private collage lookup(String name) throws ParseException {
    collage c = (collage)colTable.get(name);
    if (c == null) throw new ParseException("Collage '" + name + "' undefined");
    return (collage)c.clone();
  }

  final public void linkAlgebra(linkAlgebra alg) throws ParseException {
  result = alg;
    jj_consume_token(LEFT_BRACE);
    token_source.SwitchTo(RIGHT_BRACE_OR_NOT);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case NOT_RIGHT_BRACE:
      jj_consume_token(NOT_RIGHT_BRACE);
      definitions();
      jj_consume_token(RIGHT_BRACE);
      break;
    case IS_RIGHT_BRACE:
      jj_consume_token(IS_RIGHT_BRACE);
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void definitions() throws ParseException {
    definition();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      definitions();
      break;
    default:
      jj_la1[1] = jj_gen;
      ;
    }
  }

  final public void definition() throws ParseException {
  String name;
  collage col = new collage();
  AffineTransform trans;
  link l;
  double d;
    name = names.name();
    jj_consume_token(EQUALS);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CONST:
      jj_consume_token(CONST);
      jj_consume_token(LEFT_PAR);
      d = expr();
      jj_consume_token(RIGHT_PAR);
      if (constTable.put(name, new Double(d)) != null) {
        {if (true) throw new ParseException("constant " + name + " defined twice");}
      }
      break;
    case LEFT_BRACE:
    case USECONST:
      collageUnion(col);
      if (colTable.put(name, col) != null) {
        {if (true) throw new ParseException("collage " + name + " defined twice");}
      }
      break;
    case ROT:
    case SCALE:
    case TRANS:
    case MATRIX:
    case MAP:
    case SIM:
    case USETRANS:
      trans = composedTransformation(new AffineTransform());
      if (transTable.put(name, trans) != null) {
        {if (true) throw new ParseException("transformation " + name + " defined twice");}
      }
      break;
    case LEFT_ANGLE:
      l = link();
      if (!result.addConstant(name,l)) {
        {if (true) throw new ParseException("link " + name + " defined twice");}
      }
      break;
    default:
      jj_la1[2] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void collageUnion(collage col) throws ParseException {
  AffineTransform trans = null;
  collage tmp = new collage();
    collage(tmp);
    token_source.SwitchTo(AFTER_COLLAGE);
    label_1:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRANSFORMED2:
        ;
        break;
      default:
        jj_la1[3] = jj_gen;
        break label_1;
      }
      jj_consume_token(TRANSFORMED2);
      jj_consume_token(BY2);
      trans = transByName();
        if (trans != null) tmp.transform(trans);
        trans = null;
    }
      col.unionWith(tmp);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IS_UNION:
      jj_consume_token(IS_UNION);
      collageUnion(col);
      break;
    case NOTHING:
      jj_consume_token(NOTHING);
      break;
    default:
      jj_la1[4] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void collage(collage col) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFT_BRACE:
      jj_consume_token(LEFT_BRACE);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case STRING:
      case CURVE:
      case FILLED_CURVE:
      case CLOSED_CURVE:
      case ELLIPSE:
      case FILLED_ELLIPSE:
      case PIE:
      case FILLED_PIE:
      case ARC:
      case CLOSED_ARC:
      case FILLED_ARC:
        parts(col);
        break;
      default:
        jj_la1[5] = jj_gen;
        ;
      }
      jj_consume_token(RIGHT_BRACE);
      break;
    case USECONST:
      jj_consume_token(USECONST);
               col.unionWith(lookup(names.name()));
      break;
    default:
      jj_la1[6] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void parts(collage col) throws ParseException {
  part p;
  AffineTransform trans = null;
    p = part();
    label_2:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case TRANSFORMED:
        ;
        break;
      default:
        jj_la1[7] = jj_gen;
        break label_2;
      }
      jj_consume_token(TRANSFORMED);
      jj_consume_token(BY);
      trans = transByName();
      if (trans != null) p.transform(trans);
      trans = null;
    }
    col.add(p);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      parts(col);
      break;
    default:
      jj_la1[8] = jj_gen;
      ;
    }
  }

  final public part part() throws ParseException {
  GeneralPath seg = new GeneralPath();
  double x,y,r,rx,ry,alpha,beta;
  float pt;
  part result;
  String s,t;
  String fname = null;
  boolean bold = false;
  boolean italic = false;
  int style = part.FILLED;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case CURVE:
      jj_consume_token(CURVE);
      jj_consume_token(LEFT_PAR);
      seg = segments(false);
                                       result = new part(part.OUTLINE,seg);
      break;
    case CLOSED_CURVE:
      jj_consume_token(CLOSED_CURVE);
      jj_consume_token(LEFT_PAR);
      seg = segments(true);
                                      result = new part(part.OUTLINE,seg);
      break;
    case FILLED_CURVE:
      jj_consume_token(FILLED_CURVE);
      jj_consume_token(LEFT_PAR);
      seg = segments(true);
                                      result = new part(part.FILLED,seg);
      break;
    case ELLIPSE:
      jj_consume_token(ELLIPSE);
      jj_consume_token(LEFT_PAR);
      x = expr();
      jj_consume_token(COMMA);
      y = expr();
      jj_consume_token(COMMA);
      rx = expr();
      jj_consume_token(COMMA);
      ry = expr();
      jj_consume_token(RIGHT_PAR);
      result = new part(part.OUTLINE,new GeneralPath(new Ellipse2D.Double(x-rx,y-ry,rx*2.0,ry*2.0)));
      break;
    case FILLED_ELLIPSE:
      jj_consume_token(FILLED_ELLIPSE);
      jj_consume_token(LEFT_PAR);
      x = expr();
      jj_consume_token(COMMA);
      y = expr();
      jj_consume_token(COMMA);
      rx = expr();
      jj_consume_token(COMMA);
      ry = expr();
      jj_consume_token(RIGHT_PAR);
      result = new part(part.FILLED,new GeneralPath(new Ellipse2D.Double(x-rx,y-ry,rx*2.0,ry*2.0)));
      break;
    case PIE:
      jj_consume_token(PIE);
      jj_consume_token(LEFT_PAR);
      x = expr();
      jj_consume_token(COMMA);
      y = expr();
      jj_consume_token(COMMA);
      r = expr();
      jj_consume_token(COMMA);
      alpha = expr();
      jj_consume_token(COMMA);
      beta = expr();
      jj_consume_token(RIGHT_PAR);
      result = new part(part.OUTLINE,new GeneralPath(new Arc2D.Double(x-r,y-r,r*2.0,r*2.0,-alpha,-beta,Arc2D.PIE)));
      break;
    case FILLED_PIE:
      jj_consume_token(FILLED_PIE);
      jj_consume_token(LEFT_PAR);
      x = expr();
      jj_consume_token(COMMA);
      y = expr();
      jj_consume_token(COMMA);
      r = expr();
      jj_consume_token(COMMA);
      alpha = expr();
      jj_consume_token(COMMA);
      beta = expr();
      jj_consume_token(RIGHT_PAR);
      result = new part(part.FILLED,new GeneralPath(new Arc2D.Double(x-r,y-r,r*2.0,r*2.0,-alpha,-beta,Arc2D.PIE)));
      break;
    case ARC:
      jj_consume_token(ARC);
      jj_consume_token(LEFT_PAR);
      x = expr();
      jj_consume_token(COMMA);
      y = expr();
      jj_consume_token(COMMA);
      r = expr();
      jj_consume_token(COMMA);
      alpha = expr();
      jj_consume_token(COMMA);
      beta = expr();
      jj_consume_token(RIGHT_PAR);
      result = new part(part.OUTLINE,new GeneralPath(new Arc2D.Double(x-r,y-r,r*2.0,r*2.0,-alpha,-beta,Arc2D.OPEN)));
      break;
    case CLOSED_ARC:
      jj_consume_token(CLOSED_ARC);
      jj_consume_token(LEFT_PAR);
      x = expr();
      jj_consume_token(COMMA);
      y = expr();
      jj_consume_token(COMMA);
      r = expr();
      jj_consume_token(COMMA);
      alpha = expr();
      jj_consume_token(COMMA);
      beta = expr();
      jj_consume_token(RIGHT_PAR);
      result = new part(part.OUTLINE,new GeneralPath(new Arc2D.Double(x-r,y-r,r*2.0,r*2.0,-alpha,-beta,Arc2D.CHORD)));
      break;
    case FILLED_ARC:
      jj_consume_token(FILLED_ARC);
      jj_consume_token(LEFT_PAR);
      x = expr();
      jj_consume_token(COMMA);
      y = expr();
      jj_consume_token(COMMA);
      r = expr();
      jj_consume_token(COMMA);
      alpha = expr();
      jj_consume_token(COMMA);
      beta = expr();
      jj_consume_token(RIGHT_PAR);
      result = new part(part.FILLED,new GeneralPath(new Arc2D.Double(x-r,y-r,r*2.0,r*2.0,-alpha,-beta,Arc2D.CHORD)));
      break;
    case STRING:
      s = str();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFT_BRACKET:
        jj_consume_token(LEFT_BRACKET);
        label_3:
        while (true) {
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case STRING:
          case BOLD:
          case ITALIC:
          case OUTLINED:
            ;
            break;
          default:
            jj_la1[9] = jj_gen;
            break label_3;
          }
          switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
          case STRING:
            t = str();
                    if (fname != null && !t.equals(fname)) {if (true) throw new ParseException("Two font names specified");} fname = t;
            break;
          case BOLD:
            jj_consume_token(BOLD);
                 bold = true;
            break;
          case ITALIC:
            jj_consume_token(ITALIC);
                   italic = true;
            break;
          case OUTLINED:
            jj_consume_token(OUTLINED);
                     style = part.OUTLINE;
            break;
          default:
            jj_la1[10] = jj_gen;
            jj_consume_token(-1);
            throw new ParseException();
          }
        }
        jj_consume_token(RIGHT_BRACKET);
        break;
      default:
        jj_la1[11] = jj_gen;
        ;
      }
      jj_consume_token(SIZE);
      pt = exprf();
      if (Math.rint(Math.abs(pt)) != pt)
        {if (true) throw new ParseException("Point size of font must be a nonnegative integer");}
      jj_consume_token(AT);
      jj_consume_token(LEFT_PAR);
      x = expr();
      jj_consume_token(COMMA);
      y = expr();
      jj_consume_token(RIGHT_PAR);
      int spec = bold ? Font.BOLD : 0;
      if (italic) spec += Font.ITALIC;
      Font f = new Font(fname==null ? "SansSerif" : fname,
                        spec==0 ? Font.PLAIN : spec, Math.round(pt));
      GlyphVector gv = f.createGlyphVector(new FontRenderContext(null,false,true),s);
// For some reason, the following yields the wrong vertical placement on Mac OS X.
//      Rectangle2D b = gv.getVisualBounds();
//      GeneralPath path = new GeneralPath(gv.getOutline((float)(x-b.getCenterX()),-(float)(y+b.getCenterY())));
//      path.transform(new AffineTransform(1,0,0,-1,0,0));
      GeneralPath path = new GeneralPath(gv.getOutline());
      Rectangle2D b = path.getBounds2D();
      path.transform(new AffineTransform(1,0,0,-1,x-b.getCenterX(),y+b.getCenterY()));
      result = new part(style,path);
      break;
    default:
      jj_la1[12] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case WIDTH:
      jj_consume_token(WIDTH);
      double w = expr();
      if (w < 0) {if (true) throw new ParseException("Negative line width " + w);}
      result.setThickness(w);
      break;
    default:
      jj_la1[13] = jj_gen;
      ;
    }
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public GeneralPath segments(boolean closePath) throws ParseException {
  GeneralPath result = new GeneralPath();
    curvePoint();
    result.moveTo(px,py);
    firstCx = lx;
    firstCy = ly;
    firstPx = px;
    firstPy = py;
    close = closePath;
    tail(result,px,py,rx,ry);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public void tail(GeneralPath p, float currx, float curry, float nextCx, float nextCy) throws ParseException {
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      curvePoint();
    if (lx==0 && ly==0) {
      if (nextCx==0 && nextCy==0) p.lineTo(px,py);
      else p.quadTo(currx+nextCx,curry+nextCy,px,py);
    }
    else p.curveTo(currx+nextCx,curry+nextCy,px+lx,py+ly,px,py);
      tail(p,px,py,rx,ry);
      break;
    case RIGHT_PAR:
      jj_consume_token(RIGHT_PAR);
    if (close) {
      if (firstCx==0 && firstCy==0) {
        if (nextCx==0 && nextCy==0) p.lineTo(firstPx,firstPy);
        else p.quadTo(currx+nextCx,curry+nextCy,firstPx,firstPy);
      }
      else p.curveTo(currx+nextCx,curry+nextCy,firstCx+firstPx,firstCy+firstPy,firstPx,firstPy);
      p.closePath();
    }
      break;
    default:
      jj_la1[14] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
  }

  final public void curvePoint() throws ParseException {
  lx = ly = rx = ry = 0;
    jj_consume_token(LEFT_PAR);
    px = exprf();
    jj_consume_token(COMMA);
    py = exprf();
    jj_consume_token(RIGHT_PAR);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFT:
    case RIGHT:
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case LEFT:
        jj_consume_token(LEFT);
        jj_consume_token(LEFT_PAR);
        lx = exprf();
        jj_consume_token(COMMA);
        ly = exprf();
        jj_consume_token(RIGHT_PAR);
      rx = -lx; ry = -ly;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case RIGHT:
          jj_consume_token(RIGHT);
          jj_consume_token(LEFT_PAR);
          rx = exprf();
          jj_consume_token(COMMA);
          ry = exprf();
          jj_consume_token(RIGHT_PAR);
          break;
        default:
          jj_la1[15] = jj_gen;
          ;
        }
        break;
      case RIGHT:
        jj_consume_token(RIGHT);
        jj_consume_token(LEFT_PAR);
        rx = exprf();
        jj_consume_token(COMMA);
        ry = exprf();
        jj_consume_token(RIGHT_PAR);
      lx = -rx; ly = -ry;
        switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
        case LEFT:
          jj_consume_token(LEFT);
          jj_consume_token(LEFT_PAR);
          lx = exprf();
          jj_consume_token(COMMA);
          ly = exprf();
          jj_consume_token(RIGHT_PAR);
          break;
        default:
          jj_la1[16] = jj_gen;
          ;
        }
        break;
      default:
        jj_la1[17] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      break;
    default:
      jj_la1[18] = jj_gen;
      ;
    }
  }

  final public AffineTransform composedTransformation(AffineTransform previous) throws ParseException {
  AffineTransform trans;
    trans = transformation();
    previous.preConcatenate(trans);
    token_source.SwitchTo(COMPOSE_OR_NOT);
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case IS_COMPOSE:
      jj_consume_token(IS_COMPOSE);
      composedTransformation(previous);
      break;
    case NOT_COMPOSE:
      jj_consume_token(NOT_COMPOSE);
      break;
    default:
      jj_la1[19] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return previous;}
    throw new Error("Missing return statement in function");
  }

  final public AffineTransform transformation() throws ParseException {
  AffineTransform trans;
  double a; double b; double c; double d; double e = 0; double f = 0;
  double a2; double b2; double c2; double d2; double e2 = 0; double f2 = 0;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case USETRANS:
      trans = usedTrans();
      break;
    case ROT:
      jj_consume_token(ROT);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(RIGHT_PAR);
      trans = AffineTransform.getRotateInstance(a/180.0 * Math.PI);
      break;
    case SCALE:
      jj_consume_token(SCALE);
      jj_consume_token(LEFT_PAR);
      a = expr();
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case RIGHT_PAR:
        jj_consume_token(RIGHT_PAR);
        b = a;
        break;
      case COMMA:
        jj_consume_token(COMMA);
        b = expr();
        jj_consume_token(RIGHT_PAR);
        break;
      default:
        jj_la1[20] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
      trans = AffineTransform.getScaleInstance(a, b);
      break;
    case TRANS:
      jj_consume_token(TRANS);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(COMMA);
      b = expr();
      jj_consume_token(RIGHT_PAR);
      trans = AffineTransform.getTranslateInstance(a, b);
      break;
    case MATRIX:
      jj_consume_token(MATRIX);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(COMMA);
      b = expr();
      jj_consume_token(COMMA);
      c = expr();
      jj_consume_token(COMMA);
      d = expr();
      jj_consume_token(RIGHT_PAR);
      trans = new AffineTransform(a, c, b, d, 0, 0);
      break;
    case MAP:
      jj_consume_token(MAP);
      jj_consume_token(LEFT_PAR);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(COMMA);
      b = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(ARROW);
      jj_consume_token(LEFT_PAR);
      a2 = expr();
      jj_consume_token(COMMA);
      b2 = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(COMMA);
      jj_consume_token(LEFT_PAR);
      c = expr();
      jj_consume_token(COMMA);
      d = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(ARROW);
      jj_consume_token(LEFT_PAR);
      c2 = expr();
      jj_consume_token(COMMA);
      d2 = expr();
      jj_consume_token(RIGHT_PAR);
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case COMMA:
        jj_consume_token(COMMA);
        jj_consume_token(LEFT_PAR);
        e = expr();
        jj_consume_token(COMMA);
        f = expr();
        jj_consume_token(RIGHT_PAR);
        jj_consume_token(ARROW);
        jj_consume_token(LEFT_PAR);
        e2 = expr();
        jj_consume_token(COMMA);
        f2 = expr();
        jj_consume_token(RIGHT_PAR);
        break;
      default:
        jj_la1[21] = jj_gen;
        ;
      }
      jj_consume_token(RIGHT_PAR);
      trans = affineMapping(a, b, a2, b2, c, d, c2, d2, e, f, e2, f2);
      break;
    case SIM:
      jj_consume_token(SIM);
      jj_consume_token(LEFT_PAR);
      jj_consume_token(LEFT_PAR);
      a = expr();
      jj_consume_token(COMMA);
      b = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(ARROW);
      jj_consume_token(LEFT_PAR);
      a2 = expr();
      jj_consume_token(COMMA);
      b2 = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(COMMA);
      jj_consume_token(LEFT_PAR);
      c = expr();
      jj_consume_token(COMMA);
      d = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(ARROW);
      jj_consume_token(LEFT_PAR);
      c2 = expr();
      jj_consume_token(COMMA);
      d2 = expr();
      jj_consume_token(RIGHT_PAR);
      jj_consume_token(RIGHT_PAR);
      trans = similarity(a, b, a2, b2, c, d, c2, d2);
      break;
    default:
      jj_la1[22] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return trans;}
    throw new Error("Missing return statement in function");
  }

  final public link link() throws ParseException {
  collage col;
  link result;
  AffineTransform trans;
    jj_consume_token(LEFT_ANGLE);
                 collageUnion(col = new collage());
    jj_consume_token(COMMA);
    trans = transByName();
    jj_consume_token(RIGHT_ANGLE);
    result = new link(col);
    result.setTransform(trans);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public AffineTransform usedTrans() throws ParseException {
  AffineTransform result;
    jj_consume_token(USETRANS);
    jj_consume_token(LEFT_PAR);
    result = transByName();
    jj_consume_token(RIGHT_PAR);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public AffineTransform transByName() throws ParseException {
  AffineTransform result;
    String n = names.name();
    Object o = transTable.get(n);
    if (o == null) {if (true) throw new ParseException("Transformation '" + n + "' undefined");}
    {if (true) return (AffineTransform)((AffineTransform)o).clone();}
    throw new Error("Missing return statement in function");
  }

  final public double expr() throws ParseException {
  double result;
    result = term();
    label_4:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 69:
      case 70:
        ;
        break;
      default:
        jj_la1[23] = jj_gen;
        break label_4;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 69:
        jj_consume_token(69);
                          result += term();
        break;
      case 70:
        jj_consume_token(70);
                                                      result -= term();
        break;
      default:
        jj_la1[24] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
                                                                               {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public float exprf() throws ParseException {
  double result;
    result = expr();
                    {if (true) return (float)result;}
    throw new Error("Missing return statement in function");
  }

  final public double term() throws ParseException {
  double result;
    result = factor();
    label_5:
    while (true) {
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 71:
      case 72:
        ;
        break;
      default:
        jj_la1[25] = jj_gen;
        break label_5;
      }
      switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
      case 71:
        jj_consume_token(71);
          result *= factor();
        break;
      case 72:
        jj_consume_token(72);
                                        result /= factor();
        break;
      default:
        jj_la1[26] = jj_gen;
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public double factor() throws ParseException {
  double result, result2, result3;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case 70:
      jj_consume_token(70);
        {if (true) return -factor();}
      break;
    case USECONST:
      result = constant();
    {if (true) return result;}
      break;
    case SIN:
      jj_consume_token(SIN);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.sin(Math.PI * result / 180.0);}
      break;
    case COS:
      jj_consume_token(COS);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.cos(Math.PI * result / 180.0);}
      break;
    case TAN:
      jj_consume_token(TAN);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.tan(Math.PI * result / 180.0);}
      break;
    case SQRT:
      jj_consume_token(SQRT);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.sqrt(result);}
      break;
    case LN:
      jj_consume_token(LN);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.log(result);}
      break;
    case POWER:
      jj_consume_token(POWER);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(COMMA);
      result2 = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.pow(result,result2);}
      break;
    case MIN:
      jj_consume_token(MIN);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(COMMA);
      result2 = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.min(result,result2);}
      break;
    case MAX:
      jj_consume_token(MAX);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(COMMA);
      result2 = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return Math.max(result,result2);}
      break;
    case IFNEG:
      jj_consume_token(IFNEG);
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(COMMA);
      result2 = expr();
      jj_consume_token(COMMA);
      result3 = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return result<0 ? result2 : result3;}
      break;
    case E:
      jj_consume_token(E);
    {if (true) return Math.E;}
      break;
    case RAT:
      token = jj_consume_token(RAT);
    try { {if (true) return Double.parseDouble(token.image);} }
    catch (NumberFormatException e) {
      {if (true) throw new ParseException(token.image+" not a valid number");}
      {if (true) return 0;}
    }
      break;
    case LEFT_PAR:
      jj_consume_token(LEFT_PAR);
      result = expr();
      jj_consume_token(RIGHT_PAR);
    {if (true) return result;}
      break;
    default:
      jj_la1[27] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public double constant() throws ParseException {
    jj_consume_token(USECONST);
    String name = names.name();
    Object d = constTable.get(name);
    if (d == null) {if (true) throw new ParseException("constant " + name + " undefined");}
    {if (true) return ((Double)d).doubleValue();}
    throw new Error("Missing return statement in function");
  }

  final public String str() throws ParseException {
  Token s;
    s = jj_consume_token(STRING);
    {if (true) return s.image.substring(1,s.image.length()-1);}
    throw new Error("Missing return statement in function");
  }

  public linkAlgebraParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[28];
  final private int[] jj_la1_0 = {0x0,0x40000,0x1fc04400,0x0,0x0,0xe0000040,0x400,0x0,0x40000,0x40,0x40,0x1000,0xe0000040,0x0,0x40200,0x0,0x0,0x0,0x0,0x0,0x40200,0x40000,0x1f800000,0x0,0x0,0x0,0x0,0x180,};
  final private int[] jj_la1_1 = {0x0,0x0,0x18000,0x0,0x80000000,0x7f,0x8000,0x20000,0x0,0x3800,0x3800,0x0,0x7f,0x4000,0x0,0x100,0x80,0x180,0x180,0x60000000,0x0,0x0,0x10000,0x0,0x0,0x0,0x0,0x1ff88000,};
  final private int[] jj_la1_2 = {0x18,0x0,0x0,0x1,0x4,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x60,0x60,0x180,0x180,0x40,};

  public linkAlgebraParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new linkAlgebraParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public linkAlgebraParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new linkAlgebraParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public linkAlgebraParser(linkAlgebraParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  public void ReInit(linkAlgebraParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 28; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[73];
    for (int i = 0; i < 73; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 28; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
          if ((jj_la1_2[i] & (1<<j)) != 0) {
            la1tokens[64+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 73; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
