/* Generated By:JavaCC: Do not edit this line. termParser.java */
package parsers;

import terms.*;
import util.*;

public class termParser implements termParserConstants {

  private nameParser names;
  private ASCII_CharStream inputStream = null;
  private boolean parse_y_as_var = false;

  public termParser(ASCII_CharStream input) {
    this(new termParserTokenManager(input));
    inputStream = input;
  }

  public termParser(ASCII_CharStream input, boolean parse_y_as_var) {
      this(input);
      this.parse_y_as_var = parse_y_as_var;
  }

  public static String toString(term t) {
    symbol top = t.topSymbol();
    if (top.rank() == 0) return top.toString();
    else {
      String result = top.toString() + "[" + t.subterm(0);
      for (int i = 1; i < top.rank(); i++) result += "," + t.subterm(i);
      return result + "]";
    }
  }

  public static String unparse(term t) {
    symbol top = t.topSymbol();
    if (top.rank() == 0) return nameParser.unparse(top.toString());
    else {
      String result = nameParser.unparse(top.toString()) + "[" + unparse(t.subterm(0));
      for (int i = 1; i < top.rank(); i++) result += "," + unparse(t.subterm(i));
      return result + "]";
    }
  }

/** Parse a term.
  * The syntax is the usual one, with brackets [ and ] to enclose
  * the list of immediate subterms any two of which are separated
  * by a comma. (Sub)terms whose top-most symbol is binary, however,
  * may be denoted using infix notation. For this, the respective term
  * must be enclosed in parenthesis. For example,
  * <code>(f[a] bin (a + b))</code>
  * is equivalent to <code>bin[f[a], +[a,b]]</code>.
  * @exception ParseException if an error occurs
  */
  final public term term() throws ParseException {
  names = new nameParser(inputStream);
    term result = term2();
    token_source.SwitchTo(termParserConstants.DEFAULT);
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public term term2() throws ParseException {
  term result;
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFT_PAR:
      jj_consume_token(LEFT_PAR);
    term arg1 = term2();
    String name = names.name();
    result = new term(new symbol(name, 2));
    token_source.SwitchTo(termParserConstants.DEFAULT);
    result.defineSubterm(0, arg1);
    result.defineSubterm(1, term2());
      jj_consume_token(RIGHT_PAR);
    {if (true) return result;}
      break;
    case PREFIX:
      jj_consume_token(PREFIX);
    {if (true) return prefixNotation();}
      break;
    default:
      jj_la1[0] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  final public term prefixNotation() throws ParseException {
  term result;
  String name;
    name = names.name();
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case LEFT_BRACKET:
      jj_consume_token(LEFT_BRACKET);
      list subterms = new list();
      termList(subterms);
      int rank = subterms.length();
      result = new term(new symbol(name, rank));
      for (int i = 0; i < rank; i++) {
        result.defineSubterm(i, (term)subterms.head());
        subterms = subterms.tail();
      }
      jj_consume_token(RIGHT_BRACKET);
      break;
    case NULLARY:
      jj_consume_token(NULLARY);
    if (variable.isVariable(name)) result = new term(new variable(name));
    else if (parse_y_as_var && parameter.isParameter(name))
        result = new term(new parameter(name));
    else result = new term(new symbol(name, 0));
      break;
    default:
      jj_la1[1] = jj_gen;
      jj_consume_token(-1);
      throw new ParseException();
    }
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  final public void termList(list l) throws ParseException {
    l.append(term2());
    switch ((jj_ntk==-1)?jj_ntk():jj_ntk) {
    case COMMA:
      jj_consume_token(COMMA);
      termList(l);
      break;
    default:
      jj_la1[2] = jj_gen;
      ;
    }
  }

  public termParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[3];
  final private int[] jj_la1_0 = {0xc0,0x300,0x1000,};

  public termParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new termParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public termParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new termParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public termParser(termParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  public void ReInit(termParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 3; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[13];
    for (int i = 0; i < 13; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 3; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 13; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
