/* Generated By:JavaCC: Do not edit this line. treeEnumeratorParser.java */
package parsers;

import generators.*;

public class treeEnumeratorParser implements componentParser, treeEnumeratorParserConstants {

  private ASCII_CharStream inputStream = null;
  private treeEnumerator enm;
  private nameParser names;
  private setParser rulesParser;

  public treeEnumeratorParser(ASCII_CharStream input) {
    this(new treeEnumeratorParserTokenManager(input));
    names = new nameParser(input);
    rulesParser = new setParser(input);
    inputStream = input;
  }

/** Parse a term enumerator.
  * Expects to find the name of a symbol - the sort whose terms are to be enumerated -
  * followed by a comma, followed by a comma-separated list of sorted symbols
  * between curly braces.
  * Every symbol is given by its name followed by a colon, followed by a
  * sequence of argument sort names, an arrow (i.e., <code>-&gt;</code>),
  * and a result sort name. Distinct symbols may
  * have identical names (even if their profiles are also identical).
  * @see nameParser
  * @exception ParseException if an error occurs
  */
  final public treeEnumerator treeEnumerator() throws ParseException {
  enm = new treeEnumerator();
  String mainSort;
    jj_consume_token(LEFT_PAR);
    mainSort = names.name();
    jj_consume_token(COMMA);
    rulesParser.set(this);
    jj_consume_token(RIGHT_PAR);
    enm.initMinDepths();
    enm.setMainSort(mainSort);
    {if (true) return enm;}
    throw new Error("Missing return statement in function");
  }

  final public void component() throws ParseException {
  String name;
  String[] allSorts;
  String[] argSorts;
    name = names.name();
    jj_consume_token(COLON);
    argSorts = sortList(0);
    enm.addSymbol(name, names.name(), argSorts, 1);
  }

  final public String[] sortList(int count) throws ParseException {
    token_source.SwitchTo(ARROW_OR_NOT);
    if (token_source.getNextToken().kind == IS_ARROW) {if (true) return new String[count];}
    else {if (true) return nonemptySortList(count);}
    throw new Error("Missing return statement in function");
  }

  final public String[] nonemptySortList(int count) throws ParseException {
    String sort = names.name();
    String[] result = sortList(count +1);
    result[count] = sort;
    {if (true) return result;}
    throw new Error("Missing return statement in function");
  }

  public treeEnumeratorParserTokenManager token_source;
  ASCII_CharStream jj_input_stream;
  public Token token, jj_nt;
  private int jj_ntk;
  private int jj_gen;
  final private int[] jj_la1 = new int[0];
  final private int[] jj_la1_0 = {};

  public treeEnumeratorParser(java.io.InputStream stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new treeEnumeratorParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public treeEnumeratorParser(java.io.Reader stream) {
    jj_input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new treeEnumeratorParserTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public treeEnumeratorParser(treeEnumeratorParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  public void ReInit(treeEnumeratorParserTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
  }

  final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  final public Token getToken(int index) {
    Token t = token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  private java.util.Vector jj_expentries = new java.util.Vector();
  private int[] jj_expentry;
  private int jj_kind = -1;

  final public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[12];
    for (int i = 0; i < 12; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 0; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 12; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  final public void enable_tracing() {
  }

  final public void disable_tracing() {
  }

}
